%define	date	20130218
%define	major	5
%define	majorminor	5.9
%define	utf8libname	%mklibname %{name}w %{major}
%define	libname		%mklibname %{name} %{major}
%define	devname		%mklibname -d %{name}
%define	utf8devname	%mklibname -d %{name}w

Summary:	A CRT screen handling and optimization package
Name:		ncurses
Version:	5.9
Release:	7.%{date}.3
License:	MIT
Group:		System/Libraries
Url:		http://www.gnu.org/software/ncurses/ncurses.html
Source0:	ftp://invisible-island.net/ncurses/current/%{name}-%{version}-%{date}.tgz
Source4:	ncurses-resetall.sh
Source5:	ncurses-useful-terms
Patch1:		ncurses-5.6-xterm-debian.patch
# Alias "console" to "linux"
Patch2:		ncurses-5.9-20120811-linux-console.patch
Patch3:		ncurses-5.9-buildfix.patch
Patch7:		ncurses-5.9-urxvt.patch
Patch8:		ncurses-5.9-20121208-config-dont-print-standard-lib64-path.patch
BuildRequires:	gpm-devel
BuildRequires:	sharutils
Conflicts:	%{name}-extraterms < 5.9-6.20121026.3

%description
The curses library routines are a terminal-independent method of updating
character screens with reasonalble optimization. The ncurses (new curses)
library is a freely distributable replacement for the discontinued 4.4BSD
classic curses library.

%package -n	%{libname}
Summary:	The development files for applications which use ncurses
Group:		System/Libraries
Requires:	ncurses = %{EVRD}

%description -n	%{libname}
The curses library routines are a terminal-independent method of updating
character screens with reasonalble optimization. The ncurses (new curses)
library is a freely distributable replacement for the discontinued 4.4BSD
classic curses library.

%package -n	%{utf8libname}
Summary:	Ncurses libraries which support UTF8
Group:		System/Libraries
Requires:	ncurses = %{EVRD}

%description -n %{utf8libname}
The curses library routines are a terminal-independent method of updating
character screens with reasonalble optimization. The ncurses (new curses)
library is a freely distributable replacement for the discontinued 4.4BSD
classic curses library.

This package contains ncurses libraries which support wide char (UTF8),
and is not compatible with those without.

%package	extraterms
Summary:	Some exotic terminal descriptions
Group:		System/Libraries
Requires:	ncurses = %{EVRD}
BuildArch:	noarch

%description	extraterms
Install the ncurses-extraterms package if you use some exotic terminals.

%package -n	%{devname}
Summary:	The development files for applications which use ncurses
Group:		Development/C
Provides:	%{name}-devel = %{EVRD}
Requires:	%{libname} = %{EVRD}
Requires:	%{utf8libname} = %{EVRD}
# just keep this depdenency for untangling initial dependency issues..
%if "%{_lib}" == "lib64"
Provides:	devel(libncurses(64bit)) 
%else
Provides:	devel(libncurses) 
%endif
Provides:	pkgconfig(ncurses)

Provides:	%{utf8devname} = %{EVRD}
Obsoletes:	%{utf8devname} < 5.9-7.20130218.2

%description -n	%{devname}
The header files and libraries for developing applications that use
the ncurses CRT screen handling and optimization package.

Install the ncurses-devel package if you want to develop applications
which will use ncurses.

%package -n	termcap
Summary:	The terminal feature database used by certain applications
Group:		System/Libraries
Epoch:		1
BuildArch:	noarch

%description -n	termcap
The termcap package provides the /etc/termcap file.  /etc/termcap is
a database which defines the capabilities of various terminals and
terminal emulators.  Certain programs use the /etc/termcap file to
access various features of terminals (the bell, colors, and graphics,
etc.).

%prep
%setup -q -n %{name}-%{version}-%{date}

%patch7 -p1 -b .urxvt~

# regenerating configure needs patched autoconf, so modify configure
# directly
%patch1 -p1 -b .deb~
%patch3 -p1 -b .bf~

%patch2 -p1 -b .console~
%patch8 -p1 -b .lib64~

find . -name "*.orig" -o -name "*~" | xargs rm -f
# fix some permissions
chmod 755 c++/edit_cfg.sh test/listused.sh test/configure test/tracemunch

# we don't need nor want this, and it also pulls in a dependency on /usr/bin/make
rm -rf test/package

%build
export PKG_CONFIG_LIBDIR=%{_libdir}/pkgconfig

CONFIGURE_TOP="$PWD"

# tODO: this should die
mkdir -p ncurses-normal
pushd ncurses-normal
%configure2_5x \
	--without-libtool \
	--with-shared \
	--with-normal \
	--with-cxx \
	--without-debug \
	--enable-overwrite \
	--without-profile \
	--with-gpm \
	--enable-termcap \
	--enable-getcap \
	--enable-const \
	--enable-hard-tabs \
	--enable-hash-map \
	--enable-no-padding \
	--enable-sigwinch \
	--without-ada \
	--disable-widec \
	--enable-xmc-glitch \
	--enable-colorfgbg \
	--disable-pc-files \
	--with-ospeed=unsigned \
	--without-progs

%make
popd

mkdir -p ncurses-utf8
pushd ncurses-utf8
%configure2_5x \
	--with-pkg-config-libdir=%{_libdir}/pkgconfig \
	--without-libtool \
	--with-shared \
	--with-normal \
	--with-cxx \
	--without-debug \
	--enable-overwrite \
	--without-profile \
	--with-gpm \
	--enable-termcap \
	--enable-getcap \
	--enable-const \
	--enable-hard-tabs \
	--enable-hash-map \
	--enable-no-padding \
	--enable-sigwinch \
	--without-ada \
	--enable-widec \
	--enable-xmc-glitch \
	--enable-colorfgbg \
	--enable-pc-files \
	--with-ospeed=unsigned

%make
popd

%install
# we only install the libraries for a while untill all our packages has been
# rebuilt against the unicode version and no packages needs this anymore
pushd ncurses-normal
make install.libs DESTDIR=%{buildroot}
rm -f %{buildroot}%{_libdir}/lib*.{a,so}
popd

pushd ncurses-utf8
%makeinstall_std
popd

# the resetall script
install -m 755 %{SOURCE4} %{buildroot}%{_bindir}/resetall
# we don't want this in doc
rm -f c++/demo

mkdir -p %{buildroot}/%{_lib}
mv %{buildroot}%{_libdir}/libncurses{,w}.so.* %{buildroot}/%{_lib}
rm %{buildroot}%{_libdir}/libncursesw.so
ln -sr %{buildroot}/%{_lib}/libncursesw.so.%{majorminor} %{buildroot}%{_libdir}/libncursesw.so
for i in form menu ncurses panel; do
	ln -s lib${i}w.a %{buildroot}%{_libdir}/lib${i}.a
	ln -s lib${i}w.so %{buildroot}%{_libdir}/lib${i}.so
done
ln -s libncursesw.so %{buildroot}%{_libdir}/libcurses.so
ln -s libncursesw.a %{buildroot}%{_libdir}/libcurses.a
ln -s libncurses++w.a %{buildroot}%{_libdir}/libncurses++.a

#
# FIXME
# OK do not time to debug it now
#
cp %{buildroot}%{_datadir}/terminfo/x/xterm %{buildroot}%{_datadir}/terminfo/x/xterm2
cp %{buildroot}%{_datadir}/terminfo/x/xterm-new %{buildroot}%{_datadir}/terminfo/x/xterm

#
# remove unneeded/unwanted files
# have to be done before find commands below
#
rm -f %{buildroot}%{_libdir}/terminfo

# fwang: avoid conflict with kon package
rm -f %{buildroot}%{_datadir}/terminfo/k/kon

# bero: Build termcap from the terminfo database
mkdir -p %{buildroot}%_sysconfdir
tic -Ct misc/terminfo.src > %{buildroot}%{_sysconfdir}/termcap

#
# FIXME
#
(cd %{buildroot} ; find usr/share/terminfo      -type d | perl -pe 's||%%dir /|') > %{name}.list
(cd %{buildroot} ; find usr/share/terminfo -not -type d | perl -pe 's||/|')       > %{name}-extraterms.list
perl -pe 's||%{_datadir}/terminfo/|' %{SOURCE5} >> %{name}.list

perl -ni -e 'BEGIN { open F, "%{name}.list"; /^%/ or $s{$_} = 1 foreach <F>; } print unless $s{$_}' %{name}-extraterms.list

find %{buildroot}/%{_libdir} -name 'lib*.a' -not -type d -not -name "*_g.a" -not -name "*_p.a" -not -name "*w.a" | sed -e "s#^%{buildroot}##" > %{libname}-devel.list

# can't replace directory with symlink (rpm bug), symlink all headers
mkdir $RPM_BUILD_ROOT%{_includedir}/ncurses{,w}
for l in $RPM_BUILD_ROOT%{_includedir}/*.h; do
    ln -sr $l $RPM_BUILD_ROOT%{_includedir}/ncurses
    ln -sr $l $RPM_BUILD_ROOT%{_includedir}/ncursesw
done

%multiarch_includes %{buildroot}%{_includedir}/curses.h

%files -f %{name}.list
%doc README ANNOUNCE
%{_datadir}/tabset
%{_bindir}/*
%{_mandir}/man1/*
%{_mandir}/man5/*
%{_mandir}/man7/*

%files -n %{libname}
%attr(755,root,root) /%{_lib}/libncurses.so.%{major}*
%attr(755,root,root) %{_libdir}/libpanel.so.%{major}*
%attr(755,root,root) %{_libdir}/libmenu.so.%{major}*
%attr(755,root,root) %{_libdir}/libform.so.%{major}*

%files -n %{utf8libname}
%attr(755,root,root) /%{_lib}/libncursesw.so.%{major}*
# I have no clue on how nor where this actually gets created?!?!
%attr(755,root,root) %{_libdir}/lib*w.so.%{major}*

%files extraterms -f %{name}-extraterms.list
%doc README

%files -n %{devname}
%doc doc c++ test
%{_libdir}/libcurses.a
%{_libdir}/libcurses.so
%{_libdir}/libform.a
%{_libdir}/libform.so
%{_libdir}/libformw.a
%{_libdir}/libformw.so
%{_libdir}/libmenu.a
%{_libdir}/libmenu.so
%{_libdir}/libmenuw.a
%{_libdir}/libmenuw.so
%{_libdir}/libncurses++.a
%{_libdir}/libncurses++w.a
%{_libdir}/libncurses.a
%{_libdir}/libncurses.so
%{_libdir}/libncursesw.a
%{_libdir}/libncursesw.so
%{_libdir}/libpanel.a
%{_libdir}/libpanel.so
%{_libdir}/libpanelw.a
%{_libdir}/libpanelw.so
%{_libdir}/pkgconfig/formw.pc
%{_libdir}/pkgconfig/menuw.pc
%{_libdir}/pkgconfig/ncurses++w.pc
%{_libdir}/pkgconfig/ncursesw.pc
%{_libdir}/pkgconfig/panelw.pc
%{_includedir}/*.h
%{multiarch_includedir}/curses.h
%dir %{_includedir}/ncurses
%{_includedir}/ncurses/*.h
%dir %{_includedir}/ncursesw
%{_includedir}/ncursesw/*.h
%{_mandir}/man3/*

%files -n termcap
%{_sysconfdir}/termcap


%changelog
* Mon Mar 23 2015 Tigro <ashejn@gmail.com> 5.9-7.20130218.3
+ Revision: dc61bc5
- drop libncursesw-devel package, added more depends


